void request_MSP() {
  
#if defined (MSP_SET_RAW_RC) // Debug function only send RC data to FC
  static uint32_t RC_timer = millis();
  if (millis() > RC_timer + 1000 / 20) {
    // Variate output a little
    for (int i = 0; i < RC_CHANS; i++) {
      if (rcValue[i] > 2000)rcValue[i] = 1000;
      rcValue[i] += 10;
      SIGN[i] = rcValue[i];
    }
    
    MSP_Send(MSP_SET_RAW_RC, 8, SIGN);
    RC_timer = millis();
  }
#endif

#if (LOC_FRQ)
  static uint32_t LOC_timer = millis();
  if (millis() > LOC_timer + 1000 / LOC_FRQ) {
    send_MSP(MSP_RAW_GPS);
    LOC_timer = millis();
   // send_MSP(MSP_LOC);
    
  }
#endif

#if (Vario_FRQ)
  static uint32_t alt_timer = millis();
  if (millis() > alt_timer + 1000 / Vario_FRQ) {
    send_MSP(MSP_ALTITUDE);
    alt_timer = millis();
  }
#endif

#if (ANAL_FRQ)
  static uint32_t vbat_timer = millis();
  if (millis() > vbat_timer + 1000 / ANAL_FRQ) {
    send_MSP(MSP_ANALOG);
    vbat_timer = millis();
  }
#endif

#if (EXTRA_FRQ)
  static uint32_t vbat_timer = millis();
  if (millis() > vbat_timer + 1000 / EXTRA_FRQ) {
    send_MSP(MSP_COMP_GPS);
    vbat_timer = millis();
  }
#endif


}
/****************************************************************/
void send_MSP(int msg) {
  MSP_Send(msg, 1, 0);
}

void MSP_Send(uint8_t MSPTYPE, uint8_t ploadsize, uint16_t pload_in[12]) {
  char msp_string[20];
  char tabela[20];
  char checksum = 0;

  if (ploadsize > 0) { //non zero payload message
    uint8_t msb_pl = 0;
    uint8_t lsb_pl = 1;
    for (int i = 0; i < ploadsize; i++) {
      tabela[msb_pl] = pload_in[i] & 0xff;
      msb_pl = msb_pl + 2;
      tabela[lsb_pl] = pload_in[i] >> 8;
      lsb_pl = lsb_pl + 2;
    }
    msp_string[0] = ploadsize * 2 & 0xff;
    checksum ^= (ploadsize * 2 & 0xFF);
    msp_string[1] = MSPTYPE & 0xff;
    checksum ^= (MSPTYPE & 0xFF);
    for (int j = 0; j < (ploadsize * 2); j++) {
      msp_string[2 + j] = tabela[j] & 0xff;
      checksum ^= (tabela[j] & 0xff);
    }
    msp_string[ploadsize * 2 + 2] = checksum;
  }
  else {
    msp_string[0] = ploadsize * 2 & 0xff;
    checksum ^= (ploadsize * 2 & 0xFF);
    msp_string[1] = MSPTYPE & 0xff;
    checksum ^= (MSPTYPE & 0xFF);
    msp_string[ploadsize * 2 + 2] = checksum;
  }

  MSP_PORT.print("$M<");
  for (int u = 0; u < (ploadsize * 2 + 3); u++)
    MSP_PORT.write(msp_string[u]);

}
/*******************************************/

void blankserialRequest(uint8_t requestMSP)
{
  headSerialRequest();
  MSP_PORT.write((uint8_t)0x00);
  MSP_PORT.write(requestMSP);
  MSP_PORT.write(5);
}
/*******************************************/
void headSerialRequest (void) {
  MSP_PORT.write('$');
  MSP_PORT.write('M');
  MSP_PORT.write('<');
}
/*******************************************/
