/*
MWii Variometer
With MSP
 */
#include "def.h"

//#include <SoftwareSerial.h>
//SoftwareSerial mySerial(10, 11); // RX, TX

#define MSP_PORT         Serial  // Serial3  // mySerial
#define MSP_PORT_SPEED   115200    // 4800 // 9600

// #define Debug_PORT       Serial1  // USB/FTDI/mySerial
#define Debug_PORT_SPEED 115200

#define LOC_FRQ    0  // Poll location Freq  zero disables
#define Vario_FRQ  0  // Poll Alt + Vario Freq
#define EXTRA_FRQ  0  // distance home, direction home
#define ANAL_FRQ   0  // Vbat,Rssi etc.

#define PRINT_FRQ  1  // Debugprint function hz

#include "tones.h"
#define BUZERPIN    3   // zero = disabled

boolean ok; // Recieved data to print?
int32_t LON, LAT, GPS_time; // Location
int16_t ALT, VARIO, GPS_ALT, SPEED, distanceToHome, directionToHome, RSSI;
int8_t  FIX, NUM_SAT, VBAT;

uint16_t SIGN[8]   = {1500, 1500, 1200, 1500, 1700, 1500, 1500, 1500};
uint16_t rcValue[] = {1100, 1200, 1300, 1400, 1500, 1600, 1700, 1800};
uint16_t altalue[] = ARR_TONES;
int32_t buzztimer;
uint16_t Beepfreq;

void setup()
{
  if (BUZERPIN){
    pinMode(BUZERPIN, OUTPUT);
    trudelutt(); // Play tones
  }
  // Open serial communications and wait for port to open:
#if defined(Debug_PORT)
  Debug_PORT.begin(Debug_PORT_SPEED);
#endif
  MSP_PORT.begin(MSP_PORT_SPEED);

}

void loop() // run over and over
{
  serialMSPreceive(); // Read serial
  request_MSP();
#if defined(Debug_PORT)
  static uint32_t print_timer = millis();
  if (millis() > print_timer + 1000 / PRINT_FRQ) {
    if (ok) Print_VARIO();
    print_timer = millis();
  }
#endif

#if(BUZERPIN)
  // Play variomoeter tones
  static uint32_t Freq_timer = millis();
  Beepfreq = abs(VARIO);
  Beepfreq = 1000 /  min(Beepfreq, 20);
  if (millis() > Freq_timer + Beepfreq) {
    if (abs(VARIO) > 0 )
      set_Tone(VARIO, Beepfreq / 1.5);
    Freq_timer = millis();
  }
  if (millis() > buzztimer)
    noTone(BUZERPIN);
#endif
}
// End loop

void set_Tone(int vario, int time) {
  buzztimer = millis() + min(time, 200);
  if (vario > 0)
    tone(BUZERPIN, altalue[44 + 0]);
  if (vario < 0)
    tone(BUZERPIN, altalue[44 + 40]); //+ min(vario, 20)
}


/**************************************************************************/
void trudelutt() {
#if(BUZERPIN)
  tone(BUZERPIN, NOTE_B5);
  delay(100);
  tone(BUZERPIN, NOTE_B6);
  delay(100);
  tone(BUZERPIN, NOTE_B7);
  delay(100);
  noTone(BUZERPIN);
#endif
}



